(*Generated by Lem from abis/aarch64/abi_aarch64_program_header_table.lem.*)
(** [abi_aarch64_program_header_table], AARCH64 ABI specific program header
  * table related flags, data, etc.
  *)

open Lem_basic_classes
open Lem_num

(** AARCH64 specific segment types.  See Section 5.1 *)

(** Reserved for architecture compatibility information. *)
let abi_aarch64_pt_archext : Nat_big_num.num=  (Nat_big_num.mul( (Nat_big_num.of_int 939524096))( (Nat_big_num.of_int 2)))       (* 0x70000000 *)
(** Reserved for unwind information. *)
let abi_aarch64_pt_unwind  : Nat_big_num.num=  (Nat_big_num.add ( Nat_big_num.mul( (Nat_big_num.of_int 939524096))( (Nat_big_num.of_int 2)))( (Nat_big_num.of_int 1))) (* 0x70000001 *)

(** [string_of_abi_aarch64_segment_type m] produces a string representation of
  * an AARCH64 ABI segment type.
  *)
(*val string_of_abi_aarch64_segment_type : natural -> string*)
let string_of_abi_aarch64_segment_type m:string=
   (if Nat_big_num.equal m abi_aarch64_pt_archext then
    "ARCHEXT"
  else if Nat_big_num.equal m abi_aarch64_pt_unwind then
    "UNWIND"
  else
    "Invalid AARCH64 segment type")
